<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelFechamentoCaixaPendente  {

    protected $RelFechamentoCaixaPendente;
    protected $utilService;
    
    public function __construct(Services\RelFechamentoCaixaPendente $RelFechamentoCaixaPendente, Utilities\Util $utilService) {
        $this->RelFechamentoCaixaPendente = $RelFechamentoCaixaPendente;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if (isset($conditions['CDFILIAL'])){
            if(is_array($conditions['CDFILIAL']))
                $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            else
                $conditions['CDFILIAL'] = 'T';
        }else{
            $conditions['CDFILIAL'] = 'T';
        }
        if (isset($conditions['DTMOVTURCAIX'])){
            $DTINI = $conditions['DTMOVTURCAIX'][0];
            $DTFIN = $conditions['DTMOVTURCAIX'][1];
            $conditions['TDTMOVTURCAIX'] = 'N';
        }
        else{
            $DTINI = '';
            $DTFIN = '';
            $conditions['TDTMOVTURCAIX'] = 'T';
        }
        if (isset($conditions['CDCAIXA'])){
            if(is_array($conditions['CDCAIXA'])){
                $conditions['CDCAIXA'] = implode('_', $conditions['CDCAIXA']);
            }
            else{
                $conditions['CDCAIXA'] = 'T';
            }
        }else{
            $conditions['CDCAIXA'] = 'T';
        }
        
        $result = $this->RelFechamentoCaixaPendente->find($conditions['CDOPERADOR'], $conditions['NRORG'], $conditions['CDFILIAL'], $DTINI, $DTFIN, $conditions['TDTMOVTURCAIX'], $conditions['CDCAIXA']);
        $response->addDataSet(new DataSet("vnd55014_relFechamentoCaixaPendente", $result));
        return $response;
    }
    
}